/*
 * toolsSplit.hpp
 *
 *  Created on: Oct 21, 2015
 *      Author: javi
 */

#ifndef EXAMPLES_TOOLSSPLIT_HPP_
#define EXAMPLES_TOOLSSPLIT_HPP_

#include <string>
#include <algorithm>    // std::reverse
#include <string.h>
#include "../include/SingleTriple.hpp"

using namespace std;

vector<string> nextLevel(string node) {

	vector<string> ret;
	for (int i = 0; i < node.size(); i++) {
		if (node.at(i) == '0') {
			string newNode = node;
			newNode.at(i) = '1';
			ret.push_back(newNode);
		}
	}
	return ret;
}

set<string> getTopLevels(int combination, int numVersions) {
	string node(numVersions, '0');
	int numGraph = 0;
	int numOnes = 0;
	do {
		if ((combination & 1) != 0) {
			//numGraph is 1
			node.at(numGraph) = '1';
			numOnes++;
		}

		combination >>= 1;
		numGraph++;
	} while (combination);

	//node is a string marking the graphs
	set<string> totalPathstoRoot;
	set<string> currentlevel;
	currentlevel.insert(node);;
	for (int i = numOnes; i < numVersions; i++) {
		set<string> nextlevel;
		for (set<string>::iterator iteratorCurrent =currentlevel.begin(); iteratorCurrent!=currentlevel.end(); ++iteratorCurrent){
					vector<string> thislev = nextLevel(*iteratorCurrent);
			for (int k = 0; k < thislev.size(); k++) {
				totalPathstoRoot.insert(thislev.at(k));
				nextlevel.insert(thislev.at(k));
			}
		}
		currentlevel = nextlevel;
	}
	return totalPathstoRoot;
}

set<int, std::greater<int> > getTopLevelsInt(int combination, int numVersions) {
	//cout<<"   !!!! getTopLevelsInt, combination: "<<combination<<endl;
	string node(numVersions, '0');
	int numGraph = 0;
	int numOnes = 0;
	do {
		if ((combination & 1) != 0) {
			//numGraph is 1
			node.at(numGraph) = '1';
			numOnes++;
		}

		combination >>= 1;
		numGraph++;
	} while (combination);
	std::reverse(node.begin(), node.end());
	//cout<<"node with reverse:"<<node<<endl;

	//node is a string marking the graphs
	set<int, std::greater<int> > totalPathstoRoot;
	set<string> currentlevel;
	currentlevel.insert(node);;
	for (int i = numOnes; i < numVersions; i++) {
		set<string> nextlevel;
		for (set<string>::iterator iteratorCurrent =currentlevel.begin(); iteratorCurrent!=currentlevel.end(); ++iteratorCurrent){
					vector<string> thislev = nextLevel(*iteratorCurrent);
			for (int k = 0; k < thislev.size(); k++) {
				totalPathstoRoot.insert(std::bitset<32>(thislev.at(k)).to_ulong());
				nextlevel.insert(thislev.at(k));
			}
		}
		currentlevel = nextlevel;
	}
	return totalPathstoRoot;
}

void readQuery(std::string line, hdt::TripleString &triple){
		size_t pos_a = 0, pos_b;
		int totalLen=line.length();

		// Reads the subject
		pos_b = line.find(" ", pos_a);
		string subject = line.substr(pos_a, pos_b - pos_a);
		//if(subject[0]=='?')	subject = "";
		pos_a = pos_b + 1;

		// Reads the predicate
		pos_b = line.find(" ", pos_a);
		string predicate = line.substr(pos_a, pos_b - pos_a);
		//if(predicate[0]=='?') predicate = "";
		pos_a = pos_b + 1;

		// Reads the object
		string object = line.substr(pos_a, totalLen-pos_a);
		//if(object[0]=='?') object = "";

		triple.setAll(subject,predicate,object);
	}

#endif /* EXAMPLES_TOOLSSPLIT_HPP_ */
