/*
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Contacting the authors:
 *   Mario Arias:               mario.arias@gmail.com
 *   Javier D. Fernandez:       jfergar@infor.uva.es
 *   Miguel A. Martinez-Prieto: migumar2@infor.uva.es
 *
 */

#ifndef BASICHDTEXTENDED_HPP_
#define BASICHDTEXTENDED_HPP_

#include <HDTSpecification.hpp>
#include <HDT.hpp>

#include "BasicHDT.hpp"



namespace hdt {


class BasicHDTExtended : public BasicHDT {
private:
	ModifiableDictionary *dict;
	ModifiableTriples* triplesList;
public:
    BasicHDTExtended();
    BasicHDTExtended(HDTSpecification &spec);



	void startloadPartialDictionaries();
	void endloadPartialDictionaries();
	void endloadFromPartial(string baseUri);

	void loadPartialDictionary(Dictionary* dictionary);

	void startloadPartialTriples();
	void stoploadPartialTriples();
	void processATriple(TripleString &triple);
	void processMixTriple(string subject,int predicate,string object);
	void importDictionary(Dictionary* dict);
	void processIDTriple(hdt::TripleID ti);

};

}

#endif /* BASICHDTEXTENDED_HPP_ */
